import typing_extensions
from _typeshed import Incomplete
from azure.identity import ClientSecretCredential, DefaultAzureCredential
from azure.storage import blob
from collections.abc import Mapping
from datarobot_storage.base import SeekableKeyInterface as SeekableKeyInterface, SeekableStorage as SeekableStorage, Storage as Storage, StorageGenerator as StorageGenerator

SIGNED_BLOB_URL_TEMPLATE: str
BLOB_SAS_PERMISSIONS: Incomplete
logger: Incomplete

class AzureKey(SeekableKeyInterface):
    name: Incomplete
    client: Incomplete
    def __init__(self, name: Incomplete | None = None, client: Incomplete | None = None) -> None: ...
    def get_range(self, offset: int, size: int): ...
    @property
    def size(self): ...

class AzureBlobStorageConfig:
    prefix: str
    container_name: str | None
    connection_string: str | None
    account_name: str | None
    account_key: str | None
    tenant_id: str | None
    client_id: str | None
    client_secret: str | None
    token_file: str | None
    authority_host: str | None
    def __init__(self, prefix: str = '', container_name: str | None = None, connection_string: str | None = None, account_name: str | None = None, account_key: str | None = None, tenant_id: str | None = None, client_id: str | None = None, client_secret: str | None = None, token_file: str | None = None, authority_host: str | None = None) -> None: ...
    @property
    def is_shared_key(self) -> bool: ...
    @property
    def is_connection_string(self) -> bool: ...
    @property
    def is_service_principal(self) -> bool: ...
    @property
    def credential(self) -> DefaultAzureCredential | ClientSecretCredential | str: ...
    @property
    def account_url(self) -> str: ...
    @classmethod
    def from_dict(cls, _dict: Mapping) -> typing_extensions.Self: ...

class AzureBlobStorage(Storage):
    prefix: str
    config: AzureBlobStorageConfig
    blob_service_client: blob.BlobServiceClient
    def __init__(self, connection_string: str | None = None, account_name: str | None = None, account_key: str | None = None, container_name: str | None = None, storage_config: AzureBlobStorageConfig | None = None) -> None: ...
    @property
    def client(self) -> blob.BlobServiceClient: ...
    @property
    def container_name(self) -> str: ...
    @property
    def azure_blob_account_key(self) -> str | None: ...
    @property
    def azure_blob_account_name(self) -> str | None: ...
    def get_key(self, name: str) -> AzureKey: ...
    def exists(self, name: str) -> bool: ...
    def url(self, name: str, expires_in: int | None = 600) -> str | None: ...
    def file_size(self, name: str) -> int: ...
    def list(self, path: str, recursive: bool = False) -> list[str]: ...
    def get(self, name: str, temp_filename: str) -> bool: ...
    def get_generator(self, name: str, **kwargs) -> StorageGenerator: ...
    def put(self, name: str, local_filename: str) -> bool: ...
    def copy(self, name: str, new_name: str) -> bool: ...
    def delete(self, name: str) -> bool: ...
    def delete_all(self, name: str | None = None) -> None: ...
    def get_seekable(self, name: str) -> SeekableStorage: ...
